package org.jastadd.ros2rag.tests;

import org.jastadd.ros2rag.compiler.Compiler;
import org.jastadd.ros2rag.compiler.options.CommandLine;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import java.io.File;
import java.nio.file.Paths;
import java.util.Objects;

import static org.junit.jupiter.api.Assertions.assertTrue;

@Disabled("migrating build logic from test to build, this test is disabled for now")
public class RosToRagTest {

  void transform(String inputGrammar, String inputRos2Rag, String rootNode, String outputDir) throws CommandLine.CommandLineException, Compiler.CompilerException {

    System.out.println(Paths.get(".").toAbsolutePath());
    assertTrue(Paths.get(inputGrammar).toFile().exists(), "input grammar does not exist");

    File outputDirFile = Paths.get(outputDir).toFile();
    if (outputDirFile.exists()) {
      assertTrue(outputDirFile.isDirectory());
      if (Objects.requireNonNull(outputDirFile.list(), "Could not read output directory").length != 0) {
        System.out.println("output directory is not empty!");
      }
    } else {
      assertTrue(outputDirFile.mkdir());
    }

    String[] args = {
        "--outputDir=" + outputDir,
        "--inputGrammar=" + inputGrammar,
        "--inputRos2Rag=" + inputRos2Rag,
        "--rootNode=" + rootNode
    };

    new Compiler().run(args);
  }

  @Test
  void transformMinimalExample() throws CommandLine.CommandLineException, Compiler.CompilerException {
    transform("src/test/resources/Example.relast",
        "src/test/resources/Example.ros2rag",
        "Model",
        "src/test/resources/out");
  }
}
